import numpy as np
from ngsolve import *
from netgen.geom2d import SplineGeometry
from ngsolve import internal
import sys, time
#from functions_1E_w import *

#import room_and_parameters as room
from room_and_parameters import *


#parameters
room_length=10.66
room_width=3.3#1.5 3.3 5.7
door_width=0.5
dx = 0.1
e1=room_width/2-door_width/2
e2=room_width/2+door_width/2
ini=0.6583/11.1111
x1 = room_width
y1 = room_length
e1=room_width/2-door_width/2
e2=room_width/2+door_width/2


#geometrie
geo = SplineGeometry()

pnts =[(0,0),
   (e1,0),
   (e2,0),
   (x1,0),
   (x1,y1),
   (0,y1)
   ]

p1,E1,E2,p2,p3,p4 = [geo.AppendPoint(*pnt) for pnt in pnts]
coarse=0.25*dx
geo.Append(["line",p1,E1],leftdomain=1,rightdomain=0,bc="wall")
geo.Append(["line",E1,E2],leftdomain=1,rightdomain=0,bc="wall", maxh=coarse)
geo.Append(["line",E2,p2],leftdomain=1,rightdomain=0,bc="wall")
geo.Append(["line",p2,p3],leftdomain=1,rightdomain=0,bc="wall")
geo.Append(["line",p3,p4],leftdomain=1,rightdomain=0,bc="wall")
geo.Append(["line",p4,p1],leftdomain=1,rightdomain=0,bc="wall")

geo.SetMaterial(1,"dummy")

ngsmesh = geo.GenerateMesh(maxh=dx)
mesh = Mesh(ngsmesh)
Draw(mesh)

#input()

print('mesh done')

d=IfPos((e2-e1)*(y-e1), IfPos((e1-e2)*(y-e2), (x*(-(e2-e1))+y*0)/sqrt((e2*e2+e1*e1)), sqrt((x*x-(y-e2)*(y-e2)))),   sqrt((x*x-(y-e1)*(y-e1))))


Hfes = H1(mesh, order=1, dirichlet="wall")

gfu = GridFunction(Hfes)

print('d is set in the following, please enter')
input()

gfu.Set(d, definedon=mesh.Boundaries("wall"))

print('PDE is solved in the following, please enter')
input()
u = Hfes.TrialFunction()
v = Hfes.TestFunction()
a = BilinearForm(Hfes, symmetric=True)
a += SymbolicBFI(grad(u)*grad(v))
a.Assemble()

f = LinearForm(Hfes)
f += SymbolicLFI(0*v)
f.Assemble()

r = f.vec.CreateVector()
r.data = f.vec- a.mat * gfu.vec

gfu.vec.data += a.mat.Inverse(freedofs=Hfes.FreeDofs()) * r

Draw(gfu,mesh,"Danke fuer die Hilfe")
